#ifndef _CTRL_SOURCE_H
#define _CTRL_SOURCE_H

#include <string>

class CONTROLLER_SOURCE {

  bool dynparam_support;

 public:

  // Functions returning info about effect and its parameters.
  // ---
  virtual void set_parameter(int param, double value) { }
  virtual double get_parameter(int param) const { return 0.0; }

  bool support_for_dynamic_parameters(void) { return(dynparam_support); }
  void support_for_dynamic_parameters(bool t) { dynparam_support = t; }

  virtual string label(void) = 0;
  virtual string id_string(void) const { return(""); }
  virtual int number_of_params(void) const { return(0); }
  virtual double value(void) = 0;

};

#endif


